﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;

namespace testSQLCRUD
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        // database context
        NorthWindClassesDataContext context = new NorthWindClassesDataContext();
        Record currentAddRecord = null;
        public Window1()
        {
            InitializeComponent();

            //wire events
            xamDataGrid1.FieldLayoutInitialized += new EventHandler<Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs>(xamDataGrid1_FieldLayoutInitialized);
            xamDataGrid1.RecordUpdated += new EventHandler<Infragistics.Windows.DataPresenter.Events.RecordUpdatedEventArgs>(xamDataGrid1_RecordUpdated);
            xamDataGrid1.RecordAdded += new EventHandler<Infragistics.Windows.DataPresenter.Events.RecordAddedEventArgs>(xamDataGrid1_RecordAdded);
            
            //allow Add New
            xamDataGrid1.FieldLayoutSettings.AllowAddNew = true;
            
            //Bind grid
            xamDataGrid1.DataSource = context.Products;
        }

        void xamDataGrid1_RecordAdded(object sender, Infragistics.Windows.DataPresenter.Events.RecordAddedEventArgs e)
        {
            // this is the current add record;
            currentAddRecord = e.Record;
        }

        void xamDataGrid1_RecordUpdated(object sender, Infragistics.Windows.DataPresenter.Events.RecordUpdatedEventArgs e)
        {
            // check for the current add record
            if (e.Record == currentAddRecord)
            {
                // get the underlying data object
                Product product = (e.Record as DataRecord).DataItem as Product;

                if (String.IsNullOrEmpty(product.ProductName))
                    product.ProductName = "Automatically Selected Name";

                currentAddRecord = null;
            }
        }

        void xamDataGrid1_FieldLayoutInitialized(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs e)
        {
            // hide fields here and there
            e.FieldLayout.Fields[0].Visibility = Visibility.Collapsed;
            e.FieldLayout.Fields[4].Visibility = Visibility.Collapsed;
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            // submit all changes to the back-end database
            context.SubmitChanges();
        }
    }
}
 